/*
        TUIO processing demo - part of the reacTIVision project
        http://mtg.upf.es/reactable

        Copyright (c) 2006 Martin Kaltenbrunner <mkalten@iua.upf.es>

        Permission is hereby granted, free of charge, to any person obtaining
        a copy of this software and associated documentation files
        (the "Software"), to deal in the Software without restriction,
        including without limitation the rights to use, copy, modify, merge,
        publish, distribute, sublicense, and/or sell copies of the Software,
        and to permit persons to whom the Software is furnished to do so,
        subject to the following conditions:

        The above copyright notice and this permission notice shall be
        included in all copies or substantial portions of the Software.

        Any person wishing to distribute modifications to the Software is
        requested to send the modifications to the original developer so that
        they can be incorporated into the canonical version.

        THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
        EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
        MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
        IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR
        ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
        CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
        WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

import tuio.*;

TuiObjectList objectList;
TuiCursorList cursorList;
TuioClient client;

//carica immagini FLAT
PImage b;
PImage c;
PImage d;
PImage e;
PImage f;

float rx = random(-100,0);
float ry = -100;
float sx = random(1,100);
float sy = -100;
float tx = random(101,300);
float ty = -100;
float ux = random(301,500);
float uy = -100;
float vx = random(600,1300);
float vy = -100;

float r = random(2.0);
float s = random(2.0);
float t = random(2.0);
float u = random(2.0);
float v = random(2.0);

float layerbX, layerbY;
float layercX, layercY;
float layerdX, layerdY;
float layereX, layereY;
float layerfX, layerfY;


//carica immagini FREE TIME + THANK YOU
PImage g;
PImage h;
PImage i;
PImage l;

PImage thank;

float r2x = random(-100,0);
float r2y = -100;
float s2x = random(1,100);
float s2y = -100;
float t2x = random(101,300);
float t2y = -100;
float u2x = random(301,500);
float u2y = -100;

float v2x = random(600,1300);
float v2y = -100;


float r2 = random(2.0);
float s2 = random(2.0);
float t2 = random(2.0);
float u2 = random(2.0);

float v2 = random(2.0);

float layerb2X, layerb2Y;
float layerc2X, layerc2Y;
float layerd2X, layerd2Y;
float layere2X, layere2Y;

float layerf2X, layerf2Y;




//carica immagini BUZZ
PImage m;
PImage n;
PImage o;


float r3x = random(-100,0);
float r3y = -100;
float s3x = random(1,100);
float s3y = -100;
float t3x = random(101,300);
float t3y = -100;


float r3 = random(2.0);
float s3 = random(2.0);
float t3 = random(2.0);

float layerb3X, layerb3Y;
float layerc3X, layerc3Y;
float layerd3X, layerd3Y;


//=================//
float cuX, cuY;

int elix = 180;
int eliy = 127;
//int elix = 450;
//int eliy = 180;




void setup() {
  //size(screen.width, screen.height); /*per mettere la schermata alla stessa grandezza del desktop. Ps: vedi pure la stessa funzione in void draw.*/
  size(1280,1024);
  //background(0);
  b = loadImage("F0.png");
  c = loadImage("F1.png");
  d = loadImage("F2.png");
  e = loadImage("F3.png");
  f = loadImage("F4.png");
  
  g = loadImage("F5.png");
  h = loadImage("F6.png");
  i = loadImage("F7.png");
  l = loadImage("F8.png");
  thank = loadImage("thankyou.png");
  
  m = loadImage ("F9.png");
  n = loadImage ("F10.png");
  o = loadImage ("F11.png");
  
  
  noStroke();
  noLoop();
  redraw();
  objectList = new TuiObjectList();
  cursorList = new TuiCursorList();
  client  = new TuioClient(this);
  
}
 


// called after each message bundle
void refresh() { redraw(); }


// called when an object is added to the scene
void addTuiObject(Integer s_id, Integer f_id) {
  objectList.activate(s_id,f_id);
  //System.out.println("add object "+f_id+" ("+s_id+")");
    
}


// called when an object is removed from the scene
void removeTuiObject(Integer s_id,Integer f_id ) {
  objectList.deactivate(s_id);
  //System.out.println("remove object "+f_id+" ("+s_id+")");
  }


// funzione che visualizza la formina e che ne registra la x e la y
void updateTuiObject (Integer s_id, Integer f_id, Float xpos, Float ypos, Float angle) {
     objectList.update(s_id,(int)(600*xpos.floatValue()),(int)(600*ypos.floatValue()),angle.floatValue());
     
     //visualizza la x e la y della figurina ractable
     //System.out.println("update object ("+f_id+") ("+s_id+") ("+(int)(600*xpos.floatValue())+") ("+(int)(600*ypos.floatValue())+")");
}

//OOOOOOOOOOOOOOOOOOOOOOOOO------------------CURSORI--------------------OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

// called when a cursor appears the scene
void addTuiCursor(Integer s_id) {
  //System.out.println("add cursor "+s_id);
  cursorList.add(s_id);
  redraw();
}

// called when a cursor is removed from the scene
void removeTuiCursor(Integer s_id) {
  //System.out.println("remove cursor "+s_id);
  cursorList.remove(s_id);
  redraw();
}

// called when a cursor is moved
void updateTuiCursor (Integer s_id, Float xpos, Float ypos) {
  //System.out.println("update cursor "+s_id+" "+xpos+" "+ypos);
  cursorList.update(s_id,(int)(640*xpos.floatValue()),(int)(480*ypos.floatValue()));
  redraw();
}

//OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO0000000000000000000000000000


//helper classes

class TuiObjectList {

  java.util.Hashtable objectList;

  TuiObjectList() {
    textFont(createFont("Sans", 14));
    objectList = new Hashtable();
  }

  void draw() { 
    Enumeration e = objectList.elements();
    while (e.hasMoreElements()) {
      ((TuiObject)e.nextElement()).draw();
      
    }
  }
  
  TuiObject getObject(Integer s_id) {
    return (TuiObject)objectList.get(s_id);
  }
  
  void activate(Integer s_id, Integer f_id) { 
    TuiObject nobj = new TuiObject(s_id.intValue(), f_id.intValue());
    objectList.put(s_id,nobj);
  }
  
  void deactivate(Integer s_id) {
     objectList.remove(s_id);
     
  }
  void update(Integer s_id, int x, int y, float a) {
    TuiObject tobj = (TuiObject)objectList.get(s_id);
    if (tobj!=null) tobj.update(x,y,a);
    
  }
}


//class charge the class of objects
class TuiObject {
  int session_id, fiducial_id;
  int xpos, ypos;
  float angle;
  
  
  
  
  TuiObject(int s_id,int f_id) {
    session_id  = s_id;
    fiducial_id = f_id; 
    xpos = 0; 
    ypos = 0; 
    angle = 0.0f;
    rectMode(CENTER);
    angle = angle - 0.1;
  }

  void update(int x, int y, float a) {
    xpos=x;
    ypos=y;
    angle=a;
    
  }


   //this draw the squares related to the "organic" simbols
   void draw() {
    //background (0);
     //centro della tazza
     int cxpos = xpos+290;
     int cypos = ypos+240; 
     
      
     
    //////////////////////////////////sottobicchiere FLAT
    if (fiducial_id == 0) {
    
    // flyer flat 1
    pushMatrix();
    translate(rx,ry);
    rotate(PI*r);
    image(b, 70, 70, 250, 183);
    strokeWeight(2);
    stroke(150);
    noFill();
    ellipse(elix,eliy,60,60);
    layerbX = screenX(elix,eliy);
    layerbY = screenY(elix,eliy);
    //if (ry == cypos && rx == cxpos){r = r - 0.005;}
    popMatrix(); 
  
    
    if (ry >= cypos){
        ry = ry-8;
        if (ry >= cypos - 8 && ry <= cypos + 8){ry = cypos;}
    }
    if (ry <= cypos){ry = ry+8;
        if (ry >= cypos - 8 && ry <= cypos + 8){ry = cypos;}
    }
    if (rx >= cxpos){rx = rx-8;
        if (rx >= cxpos - 8 && rx <= cxpos + 8){rx = cxpos;}
    }
    if (rx <= cxpos){rx = rx+8;
        if (rx >= cxpos - 8 && rx <= cxpos + 8){rx = cxpos;}
    }
    if (ry != cypos && rx != cxpos){r = r- 0.005;}
    //if (ry == 0){ry = height;}
    //if (rx == 0){ry = width;}
    
    
    
     
    
    //flyer flat 3
    pushMatrix();
    translate(tx,ty);
    rotate(PI*t);
    image(d, 70, 70, 250, 183);
    strokeWeight(2);
    stroke(150);
    noFill();
    ellipse(elix,eliy,60,60);
    layerdX = screenX(elix,eliy);
    layerdY = screenY(elix,eliy);
    //t = t - 0.007;
    popMatrix(); 
    
    
    if (ty >= cypos){
        ty = ty-8;
        if (ty >= cypos - 8 && ty <= cypos + 8){ty = cypos;}
    }
    if (ty <= cypos){ty = ty+8;
        if (ty >= cypos - 8 && ty <= cypos + 8){ty = cypos;}
    }
    if (tx >= cxpos){tx = tx-8;
        if (tx >= cxpos - 8 && tx <= cxpos + 8){tx = cxpos;}
    }
    if (tx <= cxpos){tx = tx+8;
        if (tx >= cxpos - 8 && tx <= cxpos + 8){tx = cxpos;}
    }
    if (ty != cypos && tx != cxpos){t = t- 0.005;}
    
    
    //flyer flat 4
    pushMatrix();
    translate(ux,uy);
    rotate(PI*u);
    image(e, 70, 70, 250, 183);
    strokeWeight(2);
    stroke(150);
    noFill();
    ellipse(elix,eliy,60,60);
    layereX = screenX(elix,eliy);
    layereY = screenY(elix,eliy);
    //u = u - 0.0055;
    popMatrix(); 
    
    
    if (uy >= cypos){
        uy = ty-8;
        if (uy >= cypos - 8 && uy <= cypos + 8){uy = cypos;}
    }
    if (uy <= cypos){uy = uy+8;
        if (uy >= cypos - 8 && uy <= cypos + 8){uy = cypos;}
    }
    if (ux >= cxpos){ux = ux-8;
        if (ux >= cxpos - 8 && ux <= cxpos + 8){ux = cxpos;}
    }
    if (ux <= cxpos){ux = ux+8;
        if (ux >= cxpos - 8 && ux <= cxpos + 8){ux = cxpos;}
    }
    if (uy != cypos && ux != cxpos){u = u- 0.005;}
    
    
    //flyer flat 5
    pushMatrix();
    translate(vx,vy);
    rotate(PI*v);
    image(f, 70, 70, 250, 183);
    strokeWeight(2);
    stroke(150);
    noFill();
    ellipse(elix,eliy,60,60);
    layerfX = screenX(elix,eliy);
    layerfY = screenY(elix,eliy);
    //v = v - 0.006;
    popMatrix(); 
    
    
    if (vy >= cypos){
        vy = vy-8;
        if (vy >= cypos - 8 && vy <= cypos + 8){vy = cypos;}
    }
    if (vy <= cypos){vy = vy+8;
        if (vy >= cypos - 8 && vy <= cypos + 8){vy = cypos;}
    }
    if (vx >= cxpos){vx = vx-8;
        if (vx >= cxpos - 8 && vx <= cxpos + 8){vx = cxpos;}
    }
    if (vx <= cxpos){vx = vx+8;
        if (vx >= cxpos - 8 && vx <= cxpos + 8){vx = cxpos;}
    }
    if (vy != cypos && vx != cxpos){v = v- 0.005;}
    }
    
    
    
    
    //////////////////////////////////sottobicchiere NEW STUFF
    if (fiducial_id == 1) {}
      
      
    
    //////////////////////////////////sottobicchiere JOBS
    if (fiducial_id == 2) {}
    
   
    //////////////////////////////////sottobicchiere FREE TIME
    
    
    if (fiducial_id == 3) {
    
    // flyer free time 1
    pushMatrix();
    translate(r2x,r2y);
    rotate(PI*r2);
    image(g, 70, 70, 183, 250);
    strokeWeight(2);
    stroke(150);
    noFill();
    ellipse(elix,eliy,60,60);
    layerb2X = screenX(elix,eliy);
    layerb2Y = screenY(elix,eliy);
    //r2 = r2 - 0.005;
    popMatrix(); 
  
    
    if (r2y >= cypos){
        r2y = r2y-8;
        if (r2y >= cypos - 8 && r2y <= cypos + 8){r2y = cypos;}
    }
    if (r2y <= cypos){r2y = r2y+8;
        if (r2y >= cypos - 8 && r2y <= cypos + 8){r2y = cypos;}
    }
    if (r2x >= cxpos){r2x = r2x-8;
        if (r2x >= cxpos - 8 && r2x <= cxpos + 8){r2x = cxpos;}
    }
    if (r2x <= cxpos){r2x = r2x+8;
        if (r2x >= cxpos - 8 && r2x <= cxpos + 8){r2x = cxpos;}
    }
    //if (ry == 0){ry = height;}
    //if (rx == 0){ry = width;}
    if (r2y != cypos && r2x != cxpos){r2 = r2- 0.005;}
    
    
     //flyer free time 2
    pushMatrix();
    translate(s2x,s2y);
    rotate(PI*s2);
    image(h, 70, 70, 250, 183);
    strokeWeight(2);
    stroke(150);
    noFill();
    ellipse(elix,eliy,60,60);
    layerc2X = screenX(elix,eliy);
    layerc2Y = screenY(elix,eliy);
    //s2 = s2 - 0.0065;
    popMatrix(); 
    
    
    if (s2y >= cypos){
        s2y = s2y-8;
        if (s2y >= cypos - 8 && s2y <= cypos + 8){s2y = cypos;}
    }
    if (s2y <= cypos){s2y = s2y+8;
        if (s2y >= cypos - 8 && s2y <= cypos + 8){s2y = cypos;}
    }
    if (s2x >= cxpos){s2x = s2x-8;
        if (s2x >= cxpos - 8 && s2x <= cxpos + 8){s2x = cxpos;}
    }
    if (s2x <= cxpos){s2x = s2x+8;
        if (s2x >= cxpos - 8 && s2x <= cxpos + 8){s2x = cxpos;}
    }
    if (s2y != cypos && s2x != cxpos){s2 = s2- 0.005;}
    
    
    //flyer free time 3
    pushMatrix();
    translate(t2x,t2y);
    rotate(PI*t2);
    image(i, 70, 70, 250, 183);
    strokeWeight(2);
    stroke(150);
    noFill();
    ellipse(elix,eliy,60,60);
    layerd2X = screenX(elix,eliy);
    layerd2Y = screenY(elix,eliy);
    //t2 = t2 - 0.007;
    popMatrix(); 
    
    
    if (t2y >= cypos){
        t2y = t2y-8;
        if (t2y >= cypos - 8 && t2y <= cypos + 8){t2y = cypos;}
    }
    if (t2y <= cypos){t2y = t2y+8;
        if (t2y >= cypos - 8 && t2y <= cypos + 8){t2y = cypos;}
    }
    if (t2x >= cxpos){t2x = t2x-8;
        if (t2x >= cxpos - 8 && t2x <= cxpos + 8){t2x = cxpos;}
    }
    if (t2x <= cxpos){t2x = t2x+8;
        if (t2x >= cxpos - 8 && t2x <= cxpos + 8){t2x = cxpos;}
    }
    if (t2y != cypos && t2x != cxpos){t2 = t2- 0.005;}
    
    
    //flyer free time 4
    pushMatrix();
    translate(u2x,u2y);
    rotate(PI*u2);
    image(l, 70, 70, 250, 183);
    strokeWeight(2);
    stroke(150);
    noFill();
    ellipse(elix,eliy,60,60);
    layere2X = screenX(elix,eliy);
    layere2Y = screenY(elix,eliy);
    //u2 = u2 - 0.0055;
    popMatrix(); 
    
    
    if (u2y >= cypos){
        u2y = t2y-8;
        if (u2y >= cypos - 8 && u2y <= cypos + 8){u2y = cypos;}
    }
    if (u2y <= cypos){u2y = u2y+8;
        if (u2y >= cypos - 8 && u2y <= cypos + 8){u2y = cypos;}
    }
    if (u2x >= cxpos){u2x = u2x-8;
        if (u2x >= cxpos - 8 && u2x <= cxpos + 8){u2x = cxpos;}
    }
    if (u2x <= cxpos){u2x = u2x+8;
        if (u2x >= cxpos - 8 && u2x <= cxpos + 8){u2x = cxpos;}
    }
    if (u2y != cypos && u2x != cxpos){u2 = u2- 0.005;}
    }
    
    
    ///////////////////////////////////////////////////sottobicchiere BUZZ
    
    if (fiducial_id == 4) {
    
      
    // flyer buzz 1
    pushMatrix();
    translate(r3x,r3y);
    rotate(PI*r3);
    image(m, 70, 70, 250, 183);
    strokeWeight(2);
    stroke(150);
    noFill();
    ellipse(elix,eliy,60,60);
    layerb3X = screenX(elix,eliy);
    layerb3Y = screenY(elix,eliy);
    //r2 = r2 - 0.005;
    popMatrix(); 
  
    
    if (r3y >= cypos){
        r3y = r3y-8;
        if (r3y >= cypos - 8 && r3y <= cypos + 8){r3y = cypos;}
    }
    if (r3y <= cypos){r3y = r3y+8;
        if (r3y >= cypos - 8 && r3y <= cypos + 8){r3y = cypos;}
    }
    if (r3x >= cxpos){r3x = r3x-8;
        if (r2x >= cxpos - 8 && r2x <= cxpos + 8){r2x = cxpos;}
    }
    if (r3x <= cxpos){r3x = r3x+8;
        if (r3x >= cxpos - 8 && r3x <= cxpos + 8){r3x = cxpos;}
    }
    //if (ry == 0){ry = height;}
    //if (rx == 0){ry = width;}
    if (r3y != cypos && r3x != cxpos){r3 = r3- 0.005;}
    
    
  //flyer buzz 2
    pushMatrix();
    translate(s3x,s3y);
    rotate(PI*s3);
    image(n, 70, 70, 250, 183);
    strokeWeight(2);
    stroke(150);
    noFill();
    ellipse(elix,eliy,60,60);
    layerc3X = screenX(elix,eliy);
    layerc3Y = screenY(elix,eliy);
    //s = s - 0.0045;
    popMatrix(); 
    
    
    if (s3y >= cypos){
        s3y = s3y-8;
        if (s3y >= cypos - 8 && s3y <= cypos + 8){s3y = cypos;}
    }
    if (s3y <= cypos){s3y = s3y+8;
        if (s3y >= cypos - 8 && s3y <= cypos + 8){s3y = cypos;}
    }
    if (s3x >= cxpos){s3x = s3x-8;
        if (s3x >= cxpos - 8 && s3x <= cxpos + 8){s3x = cxpos;}
    }
    if (s3x <= cxpos){s3x = s3x+8;
        if (s3x >= cxpos - 8 && s3x <= cxpos + 8){s3x = cxpos;}
    }
    if (s3y != cypos && s3x != cxpos){s3 = s3- 0.005;}
    
    
    //flyer buzz 3
    pushMatrix();
    translate(t3x,t3y);
    rotate(PI*t3);
    image(o, 70, 70, 250, 183);
    strokeWeight(2);
    stroke(150);
    noFill();
    ellipse(elix,eliy,60,60);
    layerd3X = screenX(elix,eliy);
    layerd3Y = screenY(elix,eliy);
    //t2 = t2 - 0.007;
    popMatrix(); 
    
    
    if (t3y >= cypos){
        t3y = t3y-8;
        if (t3y >= cypos - 8 && t3y <= cypos + 8){t3y = cypos;}
    }
    if (t3y <= cypos){t3y = t3y+8;
        if (t3y >= cypos - 8 && t3y <= cypos + 8){t3y = cypos;}
    }
    if (t3x >= cxpos){t3x = t3x-8;
        if (t3x >= cxpos - 8 && t3x <= cxpos + 8){t3x = cxpos;}
    }
    if (t3x <= cxpos){t3x = t3x+8;
        if (t3x >= cxpos - 8 && t3x <= cxpos + 8){t3x = cxpos;}
    }
    if (t3y != cypos && t3x != cxpos){t3 = t3- 0.005;}


}
    
    
    
    
    //////////////////////////////////sottobicchiere THANK YOU
    
    if (fiducial_id == 5){
    
    //flyer Thank you
    pushMatrix();
    translate(v2x,v2y);
    rotate(PI*v2);
    image(thank, 70, 70, 250, 183);
    strokeWeight(2);
    stroke(150);
    noFill();
    ellipse(elix,eliy,60,60);
    layerf2X = screenX(elix,eliy);
    layerf2Y = screenY(elix,eliy);
    v2 = v2 - 0.006;
    popMatrix(); 
    
    
    if (v2y >= cypos){
        v2y = v2y-8;
        if (v2y >= cypos - 8 && v2y <= cypos + 8){v2y = cypos;}
    }
    if (v2y <= cypos){v2y = v2y+8;
        if (v2y >= cypos - 8 && v2y <= cypos + 8){v2y = cypos;}
    }
    if (v2x >= cxpos){v2x = v2x-8;
        if (v2x >= cxpos - 8 && v2x <= cxpos + 8){v2x = cxpos;}
    }
    if (v2x <= cxpos){v2x = v2x+8;
        if (v2x >= cxpos - 8 && v2x <= cxpos + 8){v2x = cxpos;}
    }
    
    }
    
    
    
    //rettangolo del sottobicchiere
    pushMatrix();
    translate(cxpos,cypos);
    
    rotate(angle);
    rectMode(CENTER);
    fill(230);
    noStroke();
    rect(0,0,250,250);
    popMatrix();
    
    
}
}



void draw() {
  
  background(210);
  cursorList.draw();
  objectList.draw();
}







class TuiCursorList {

  java.util.Hashtable cursorList;

  TuiCursorList() {
    cursorList = new Hashtable();
  }

  void draw() {
    Point ultimop;
    stroke(150);
    strokeWeight(10);
    Enumeration e = cursorList.elements();
    
    int w = int(layerbX);
    int j = int(layerbY);
    int w1 = int(layercX);
    int j1 = int(layercY);
    int w2 = int(layerdX);
    int j2 = int(layerdY);
    int w3 = int(layereX);
    int j3 = int(layereY);
    int w4 = int(layerfX);
    int j4 = int(layerfY);
    
    int w02 = int(layerb2X);
    int j02 = int(layerb2Y);
    int w21 = int(layerc2X);
    int j21 = int(layerc2Y);
    int w22 = int(layerd2X);
    int j22 = int(layerd2Y);
    int w23 = int(layere2X);
    int j23 = int(layere2Y);
    
    int w24 = int(layerf2X);
    int j24 = int(layerf2Y);
    
    int w03 = int(layerb3X);
    int j03 = int(layerb3Y);
    int w31 = int(layerc3X);
    int j31 = int(layerc3Y);
    int w32 = int(layerd3X);
    int j32 = int(layerd3Y);
    
    println(w + ","+j);
    
    while (e.hasMoreElements()) {
      Vector pointList = (Vector)e.nextElement();
      
      if (pointList.size()>0) {
        Point start_point = (Point)pointList.elementAt(0);
        for (int i=0;i<pointList.size();i++) {
           Point end_point = (Point)pointList.elementAt(i);
           line(start_point.x +220.0,start_point.y +300.0,end_point.x +220.0,end_point.y +300);
           start_point = end_point;
           ultimop = (Point)pointList.elementAt(pointList.size() - 1);
           
           cuX = screenX(ultimop.x,ultimop.y);
           cuY = screenY(ultimop.x,ultimop.y);
           println(cuX + "," + cuY);
                  
        } 
        }
        
        }
        
        int cuXv = int(cuX);
        int cuYv = int(cuY);
       if (cuXv >= w-30 && cuXv <= w+30 && cuYv >= j-30 && cuYv <= j+30){
        rx = cuXv - 370;
        ry = cuYv - 290;
        r = 0;
        }
       if (cuXv >= w1-30 && cuXv <= w1+30 && cuYv >= j1-30 && cuYv <= j1+30){
        sx = cuXv - 370;
        sy = cuYv - 290;
        s = 0;
        }
       if (cuXv >= w2-30 && cuXv <= w2+30 && cuYv >= j2-30 && cuYv <= j2+30){
        tx = cuXv - 370;
        ty = cuYv - 290;
        t = 0;
        }
       if (cuXv >= w3-30 && cuXv <= w3+30 && cuYv >= j3-30 && cuYv <= j3+30){
        ux = cuXv - 370;
        uy = cuYv - 290;
        u = 0;
        }
       if (cuXv >= w4-30 && cuXv <= w4+30 && cuYv >= j4-30 && cuYv <= j4+30){
        vx = cuXv - 370;
        vy = cuYv - 290;
        v = 0;
        }
       
       
       if (cuXv >= w02-30 && cuXv <= w02+30 && cuYv >= j02-30 && cuYv <= j02+30){
        r2x = cuXv - 370;
        r2y = cuYv - 290;
        r2 = 0;
        }
       if (cuXv >= w21-30 && cuXv <= w21+30 && cuYv >= j21-30 && cuYv <= j21+30){
        s2x = cuXv - 370;
        s2y = cuYv - 290;
        s2 = 0;
        }
       if (cuXv >= w22-30 && cuXv <= w22+30 && cuYv >= j22-30 && cuYv <= j22+30){
        t2x = cuXv - 370;
        t2y = cuYv - 290;
        t2 = 0;
        }
       if (cuXv >= w23-30 && cuXv <= w23+30 && cuYv >= j23-30 && cuYv <= j23+30){
        u2x = cuXv - 370;
        u2y = cuYv - 290;
        u2 = 0;
        }
       if (cuXv >= w24-30 && cuXv <= w24+30 && cuYv >= j24-30 && cuYv <= j24+30){
        v2x = cuXv - 370;
        v2y = cuYv - 290;
        v2 = 0;
        }  
  







}
  
  void add(Integer s_id) { 
    Vector pointList = new Vector();
    cursorList.put(s_id,pointList);
  }
  
  void remove(Integer s_id) {
    cursorList.remove(s_id);
  }
  
  void update(Integer s_id, int xpos, int ypos) {
    Vector pointList = (Vector)cursorList.get(s_id);
    if (pointList!=null) pointList.addElement(new Point(xpos,ypos));
  }
}
